Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task_sync.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task_sync.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task_sync.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -118,5 +118,5 @@
 
 /*
- *  起床待ち
+ *  起床待ち［NGKI1252］
  */
 #ifdef TOPPERS_slp_tsk
@@ -129,17 +129,16 @@
 
 	LOG_SLP_TSK_ENTER();
-	CHECK_DISPATCH();
+	CHECK_DISPATCH();							/*［NGKI1254］*/
 
 	lock_cpu_dsp();
 	if (p_runtsk->raster) {
-		ercd = E_RASTER;
+		ercd = E_RASTER;						/*［NGKI3455］*/
 	}
 	else if (p_runtsk->wupque) {
-		p_runtsk->wupque = false;
-		ercd = E_OK;
-	}
-	else {
-		p_runtsk->tstat = TS_WAITING_SLP;
-		make_wait(&winfo);
+		p_runtsk->wupque = false;				/*［NGKI1259］*/
+		ercd = E_OK;
+	}
+	else {
+		make_wait(TS_WAITING_SLP, &winfo);		/*［NGKI1260］*/
 		LOG_TSKSTAT(p_runtsk);
 		dispatch();
@@ -156,5 +155,5 @@
 
 /*
- *  起床待ち（タイムアウトあり）
+ *  起床待ち（タイムアウトあり）［NGKI1253］
  */
 #ifdef TOPPERS_tslp_tsk
@@ -168,21 +167,20 @@
 
 	LOG_TSLP_TSK_ENTER(tmout);
-	CHECK_DISPATCH();
-	CHECK_PAR(VALID_TMOUT(tmout));
+	CHECK_DISPATCH();							/*［NGKI1254］*/
+	CHECK_PAR(VALID_TMOUT(tmout));				/*［NGKI1256］*/
 
 	lock_cpu_dsp();
 	if (p_runtsk->raster) {
-		ercd = E_RASTER;
+		ercd = E_RASTER;						/*［NGKI3455］*/
 	}
 	else if (p_runtsk->wupque) {
-		p_runtsk->wupque = false;
+		p_runtsk->wupque = false;				/*［NGKI1259］*/
 		ercd = E_OK;
 	}
 	else if (tmout == TMO_POL) {
-		ercd = E_TMOUT;
-	}
-	else {
-		p_runtsk->tstat = TS_WAITING_SLP;
-		make_wait_tmout(&winfo, &tmevtb, tmout);
+		ercd = E_TMOUT;							/*［NGKI1257］*/
+	}
+	else {										/*［NGKI1260］*/
+		make_wait_tmout(TS_WAITING_SLP, &winfo, &tmevtb, tmout);
 		LOG_TSKSTAT(p_runtsk);
 		dispatch();
@@ -199,5 +197,5 @@
 
 /*
- *  タスクの起床
+ *  タスクの起床［NGKI3531］
  */
 #ifdef TOPPERS_wup_tsk
@@ -210,10 +208,10 @@
 
 	LOG_WUP_TSK_ENTER(tskid);
-	CHECK_UNL();
+	CHECK_UNL();								/*［NGKI1265］*/
 	if (tskid == TSK_SELF && !sense_context()) {
-		p_tcb = p_runtsk;
-	}
-	else {
-		CHECK_ID(VALID_TSKID(tskid));
+		p_tcb = p_runtsk;						/*［NGKI1275］*/
+	}
+	else {
+		CHECK_ID(VALID_TSKID(tskid));			/*［NGKI1267］*/
 		p_tcb = get_tcb(tskid);
 	}
@@ -221,11 +219,11 @@
 	lock_cpu();
 	if (p_tcb->p_tinib->tskatr == TA_NOEXS) {
-		ercd = E_NOEXS;
+		ercd = E_NOEXS;							/*［NGKI1268］*/
 	}
 	else if (TSTAT_DORMANT(p_tcb->tstat)) {
-		ercd = E_OBJ;
+		ercd = E_OBJ;							/*［NGKI1270］*/
 	}
 	else if (TSTAT_WAIT_SLP(p_tcb->tstat)) {
-		wait_complete(p_tcb);
+		wait_complete(p_tcb);					/*［NGKI1271］*/
 		if (p_runtsk != p_schedtsk) {
 			if (!sense_context()) {
@@ -233,5 +231,5 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
@@ -239,9 +237,9 @@
 	}
 	else if (!(p_tcb->wupque)) {
-		p_tcb->wupque = true;
-		ercd = E_OK;
-	}
-	else {
-		ercd = E_QOVR;
+		p_tcb->wupque = true;					/*［NGKI1273］*/
+		ercd = E_OK;
+	}
+	else {
+		ercd = E_QOVR;							/*［NGKI1274］*/
 	}
 	unlock_cpu();
@@ -255,5 +253,5 @@
 
 /*
- *  タスク起床要求のキャンセル
+ *  タスク起床要求のキャンセル［NGKI1276］
  */
 #ifdef TOPPERS_can_wup
@@ -266,10 +264,10 @@
 
 	LOG_CAN_WUP_ENTER(tskid);
-	CHECK_TSKCTX_UNL();
+	CHECK_TSKCTX_UNL();							/*［NGKI1277］［NGKI1278］*/
 	if (tskid == TSK_SELF) {
-		p_tcb = p_runtsk;
-	}
-	else {
-		CHECK_ID(VALID_TSKID(tskid));
+		p_tcb = p_runtsk;						/*［NGKI1285］*/
+	}
+	else {
+		CHECK_ID(VALID_TSKID(tskid));			/*［NGKI1280］*/
 		p_tcb = get_tcb(tskid);
 	}
@@ -277,12 +275,12 @@
 	lock_cpu();
 	if (p_tcb->p_tinib->tskatr == TA_NOEXS) {
-		ercd = E_NOEXS;
+		ercd = E_NOEXS;							/*［NGKI1281］*/
 	}
 	else if (TSTAT_DORMANT(p_tcb->tstat)) {
-		ercd = E_OBJ;
-	}
-	else {
-		ercd = p_tcb->wupque ? 1 : 0;
-		p_tcb->wupque = false;
+		ercd = E_OBJ;							/*［NGKI1283］*/
+	}
+	else {
+		ercd = p_tcb->wupque ? 1 : 0;			/*［NGKI1284］*/
+		p_tcb->wupque = false;					/*［NGKI1284］*/
 	}
 	unlock_cpu();
@@ -296,5 +294,5 @@
 
 /*
- *  待ち状態の強制解除
+ *  待ち状態の強制解除［NGKI3532］
  */
 #ifdef TOPPERS_rel_wai
@@ -307,19 +305,19 @@
 
 	LOG_REL_WAI_ENTER(tskid);
-	CHECK_UNL();
-	CHECK_ID(VALID_TSKID(tskid));
+	CHECK_UNL();								/*［NGKI1290］*/
+	CHECK_ID(VALID_TSKID(tskid));				/*［NGKI1292］*/
 	p_tcb = get_tcb(tskid);
 
 	lock_cpu();
 	if (p_tcb->p_tinib->tskatr == TA_NOEXS) {
-		ercd = E_NOEXS;
+		ercd = E_NOEXS;							/*［NGKI1293］*/
 	}
 	else if (!TSTAT_WAITING(p_tcb->tstat)) {
-		ercd = E_OBJ;
-	}
-	else {
-		wait_dequeue_wobj(p_tcb);
+		ercd = E_OBJ;							/*［NGKI1295］*/
+	}
+	else {
+		wait_dequeue_wobj(p_tcb);				/*［NGKI1296］*/
 		wait_dequeue_tmevtb(p_tcb);
-		p_tcb->p_winfo->wercd = E_RLWAI;
+		p_tcb->p_winfo->wercd = E_RLWAI;		/*［NGKI1297］*/
 		make_non_wait(p_tcb);
 		if (p_runtsk != p_schedtsk) {
@@ -328,5 +326,5 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
@@ -409,5 +407,5 @@
 
 /*
- *  強制待ち状態からの再開
+ *  強制待ち状態からの再開［NGKI1312］
  */
 #ifdef TOPPERS_rsm_tsk
@@ -420,33 +418,31 @@
 
 	LOG_RSM_TSK_ENTER(tskid);
-	CHECK_TSKCTX_UNL();
-	CHECK_ID(VALID_TSKID(tskid));
+	CHECK_TSKCTX_UNL();							/*［NGKI1313］［NGKI1314］*/
+	CHECK_ID(VALID_TSKID(tskid));				/*［NGKI1316］*/
 	p_tcb = get_tcb(tskid);
 
 	lock_cpu();
 	if (p_tcb->p_tinib->tskatr == TA_NOEXS) {
-		ercd = E_NOEXS;
+		ercd = E_NOEXS;							/*［NGKI1317］*/
 	}
 	else if (!TSTAT_SUSPENDED(p_tcb->tstat)) {
-		ercd = E_OBJ;
-	}
-	else if (!TSTAT_WAITING(p_tcb->tstat)) {
+		ercd = E_OBJ;							/*［NGKI1319］*/
+	}
+	else {
 		/*
-		 *  強制待ち状態から実行できる状態への遷移
+		 *  強制待ちからの再開［NGKI1320］
 		 */
-		p_tcb->tstat = TS_RUNNABLE;
-		LOG_TSKSTAT(p_tcb);
-		make_runnable(p_tcb);
-		if (p_runtsk != p_schedtsk) {
-			dispatch();
+		if (!TSTAT_WAITING(p_tcb->tstat)) {
+			p_tcb->tstat = TS_RUNNABLE;
+			LOG_TSKSTAT(p_tcb);
+			make_runnable(p_tcb);
+			if (p_runtsk != p_schedtsk) {
+				dispatch();
+			}
 		}
-		ercd = E_OK;
-	}
-	else {
-		/*
-		 *  二重待ち状態から待ち状態への遷移
-		 */
-		p_tcb->tstat &= ~TS_SUSPENDED;
-		LOG_TSKSTAT(p_tcb);
+		else {
+			p_tcb->tstat &= ~TS_SUSPENDED;
+			LOG_TSKSTAT(p_tcb);
+		}
 		ercd = E_OK;
 	}
@@ -461,5 +457,5 @@
 
 /*
- *  自タスクの遅延
+ *  自タスクの遅延［NGKI1348］
  */
 #ifdef TOPPERS_dly_tsk
@@ -473,13 +469,13 @@
 
 	LOG_DLY_TSK_ENTER(dlytim);
-	CHECK_DISPATCH();
-	CHECK_PAR(VALID_RELTIM(dlytim));
+	CHECK_DISPATCH();							/*［NGKI1349］*/
+	CHECK_PAR(VALID_RELTIM(dlytim));			/*［NGKI1351］*/
 
 	lock_cpu_dsp();
 	if (p_runtsk->raster) {
-		ercd = E_RASTER;
-	}
-	else {
-		p_runtsk->tstat = TS_WAITING_DLY;
+		ercd = E_RASTER;						/*［NGKI3456］*/
+	}
+	else {
+		p_runtsk->tstat = TS_WAITING_DLY;		/*［NGKI1353］*/
 		make_non_runnable(p_runtsk);
 		p_runtsk->p_winfo = &winfo;
@@ -487,5 +483,5 @@
 		tmevtb.callback = (CBACK) wait_tmout_ok;
 		tmevtb.arg = (void *) p_runtsk;
-		tmevtb_enqueue(&tmevtb, dlytim);
+		tmevtb_enqueue_reltim(&tmevtb, dlytim);
 		LOG_TSKSTAT(p_runtsk);
 		dispatch();
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/task_term.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/task_term.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/task_term.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2017 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -109,5 +109,4 @@
 ext_tsk(void)
 {
-	PRI		intpri;
 	ER		ercd;
 
@@ -126,6 +125,5 @@
 	}
 
-	intpri = t_get_ipm();
-	if (!enadsp || intpri != TIPM_ENAALL) {
+	if (!dspflg) {
 		if (!enadsp) {
 			/*
@@ -135,5 +133,5 @@
 			enadsp = true;
 		}
-		if (intpri != TIPM_ENAALL) {
+		if (t_get_ipm() != TIPM_ENAALL) {
 			/*
 			 *  割込み優先度マスク（IPM）がTIPM_ENAALL以外の状態で
@@ -143,6 +141,5 @@
 			t_set_ipm(TIPM_ENAALL);
 		}
-		dspflg = true;
-		p_schedtsk = search_schedtsk();
+		set_dspflg();
 	}
 
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/time_event.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/time_event.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/time_event.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -49,4 +49,11 @@
 
 /*
+ *  TCYC_HRTCNTの定義のチェック
+ */
+#if defined(USE_64BIT_HRTCNT) && defined(TCYC_HRTCNT)
+#error TCYC_HRTCNT must not be defined when USE_64BIT_HRTCNT.
+#endif
+
+/*
  *  TSTEP_HRTCNTの範囲チェック
  */
@@ -56,6 +63,8 @@
 
 /*
- *  HRTCNT_BOUNDの範囲チェック
- */
+ *  HRTCNT_BOUNDの定義のチェック
+ */
+#ifndef USE_64BIT_HRTCNT
+
 #if HRTCNT_BOUND >= 4294000000U
 #error HRTCNT_BOUND is too large.
@@ -67,4 +76,12 @@
 #endif /* HRTCNT_BOUND >= TCYC_HRTCNT */
 #endif /* TCYC_HRTCNT */
+
+#else /* USE_64BIT_HRTCNT */
+
+#ifdef HRTCNT_BOUND
+#error USE_64BIT_HRTCNT is not supported on this target.
+#endif /* HRTCNT_BOUND */
+
+#endif /* USE_64BIT_HRTCNT */
 
 /*
@@ -367,8 +384,8 @@
 	}
 #endif /* TCYC_HRTCNT */
+	current_hrtcnt = new_hrtcnt;					/*［ASPD1016］*/
 
 	previous_evttim = current_evttim;
 	current_evttim += (EVTTIM) hrtcnt_advance;		/*［ASPD1015］*/
-	current_hrtcnt = new_hrtcnt;					/*［ASPD1016］*/
 	boundary_evttim = current_evttim - BOUNDARY_MARGIN;	/*［ASPD1011］*/
 
@@ -407,5 +424,12 @@
 
 	if (p_last_tmevtn < p_top_tmevtn) {
+		/*
+		 *  タイムイベントがない場合
+		 */
+#ifdef USE_64BIT_HRTCNT
+		target_hrt_clear_event();
+#else /* USE_64BIT_HRTCNT */
 		target_hrt_set_event(HRTCNT_BOUND);			/*［ASPD1007］*/
+#endif /* USE_64BIT_HRTCNT */
 	}
 	else if (EVTTIM_LE(top_evttim, current_evttim)) {
@@ -414,4 +438,7 @@
 	else {
 		hrtcnt = (HRTCNT)(top_evttim - current_evttim);
+#ifdef USE_64BIT_HRTCNT
+		target_hrt_set_event(hrtcnt);
+#else /* USE_64BIT_HRTCNT */
 		if (hrtcnt > HRTCNT_BOUND) {
 			target_hrt_set_event(HRTCNT_BOUND);		/*［ASPD1006］*/
@@ -420,4 +447,5 @@
 			target_hrt_set_event(hrtcnt);			/*［ASPD1002］*/
 		}
+#endif /* USE_64BIT_HRTCNT */
 	}
 }
@@ -442,8 +470,8 @@
  *  
  */
-#ifdef TOPPERS_tmeenq
+#ifdef TOPPERS_tmeenqrel
 
 void
-tmevtb_enqueue(TMEVTB *p_tmevtb, RELTIM time)
+tmevtb_enqueue_reltim(TMEVTB *p_tmevtb, RELTIM time)
 {
 	/*
@@ -467,5 +495,5 @@
 }
 
-#endif /* TOPPERS_tmeenq */
+#endif /* TOPPERS_tmeenqrel */
 
 /*
@@ -502,9 +530,9 @@
 
 bool_t
-check_adjtim(int_t adjtim)
+check_adjtim(int32_t adjtim)
 {
 	if (adjtim > 0) {
 		return(p_last_tmevtn >= p_top_tmevtn	/*［NGKI3588］*/
-					&& EVTTIM_LE(top_evttim, current_evttim - TMAX_ADJTIM));
+					&& EVTTIM_LE(top_evttim + TMAX_ADJTIM, current_evttim));
 	}
 	else if (adjtim < 0) {						/*［NGKI3589］*/
@@ -559,4 +587,7 @@
 	TMEVTB	*p_tmevtb;
 	bool_t	callflag;
+#ifndef TOPPERS_OMIT_SYSLOG
+	uint_t	nocall = 0;
+#endif /* TOPPERS_OMIT_SYSLOG */
 
 	assert(sense_context());
@@ -587,7 +618,19 @@
 			(*(p_tmevtb->callback))(p_tmevtb->arg);
 			callflag = true;
+#ifndef TOPPERS_OMIT_SYSLOG
+			nocall += 1;
+#endif /* TOPPERS_OMIT_SYSLOG */
 		}
 	} while (callflag);								/*［ASPD1020］*/
 
+#ifndef TOPPERS_OMIT_SYSLOG
+	/*
+	 *  タイムイベントが処理されなかった場合．
+	 */
+	if (nocall == 0) {
+		syslog_0(LOG_NOTICE, "no time event is processed in hrt interrupt.");
+	}
+#endif /* TOPPERS_OMIT_SYSLOG */
+
 	/*
 	 *  高分解能タイマ割込みの発生タイミングを設定する［ASPD1025］．
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/time_event.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/time_event.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/time_event.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -162,4 +162,8 @@
  *  の発生時刻，コールバック関数，コールバック関数へ渡す引数は，
  *  p_tmevtbが指すタイムイベントブロック中に設定しておく．
+ *
+ *  高分解能タイマ割込みの発生タイミングの設定を行わないため，カーネル
+ *  の初期化時か，高分解能タイマ割込みの処理中で，それが必要ない場合に
+ *  のみ使用する．
  */
 extern void		tmevtb_register(TMEVTB *p_tmevtb);
@@ -173,5 +177,5 @@
  *  ントブロック中に設定しておく．
  */
-extern void		tmevtb_enqueue(TMEVTB *p_tmevtb, RELTIM time);
+extern void		tmevtb_enqueue_reltim(TMEVTB *p_tmevtb, RELTIM time);
 
 /*
@@ -187,5 +191,5 @@
  *  ベント時刻を取得した後に呼び出すことを想定している．
  */
-extern bool_t	check_adjtim(int_t adjtim);
+extern bool_t	check_adjtim(int32_t adjtim);
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/time_manage.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/time_manage.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/time_manage.c	(revision 429)
@@ -53,4 +53,5 @@
 #include "time_event.h"
 #include "target_timer.h"
+#include <sil.h>
 
 /*
@@ -98,13 +99,18 @@
 {
 	ER		ercd;
+	bool_t lock;
 
 	LOG_SET_TIM_ENTER(systim);
-	CHECK_TSKCTX_UNL();							/*［NGKI3564］［NGKI3565］*/
-
-	lock_cpu();
+	//CHECK_TSKCTX_UNL();							/*［NGKI3564］［NGKI3565］*/
+	CHECK_TSKCTX();
+	lock = sense_lock();
+
+	if (!lock)
+		lock_cpu();
 	update_current_evttim();					/*［ASPD1059］*/
 	systim_offset = systim - monotonic_evttim;	/*［ASPD1060］*/
 	ercd = E_OK;
-	unlock_cpu();
+	if (!lock)
+		unlock_cpu();
 
   error_exit:
@@ -124,13 +130,18 @@
 {
 	ER		ercd;
+	bool_t lock;
 
 	LOG_GET_TIM_ENTER(p_systim);
-	CHECK_TSKCTX_UNL();							/*［NGKI2350］［NGKI2351］*/
-
-	lock_cpu();
+	//CHECK_TSKCTX_UNL();							/*［NGKI2350］［NGKI2351］*/
+	CHECK_TSKCTX();
+	lock = sense_lock();
+
+	if (!lock)
+		lock_cpu();
 	update_current_evttim();					/*［ASPD1057］*/
 	*p_systim = systim_offset + monotonic_evttim;	/*［ASPD1058］*/
 	ercd = E_OK;
-	unlock_cpu();
+	if (!lock)
+		unlock_cpu();
 
   error_exit:
@@ -176,5 +187,7 @@
 		}
 
-		set_hrt_event();						/*［ASPD1056］*/
+		if (!in_signal_time) {
+			set_hrt_event();					/*［ASPD1056］*/
+		}
 		ercd = E_OK;
 	}
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/wait.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/wait.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/wait.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -54,6 +54,7 @@
 
 void
-make_wait_tmout(WINFO *p_winfo, TMEVTB *p_tmevtb, TMO tmout)
+make_wait_tmout(uint_t tstat, WINFO *p_winfo, TMEVTB *p_tmevtb, TMO tmout)
 {
+	p_runtsk->tstat = tstat;
 	make_non_runnable(p_runtsk);
 	p_runtsk->p_winfo = p_winfo;
@@ -66,5 +67,5 @@
 		p_tmevtb->callback = (CBACK) wait_tmout;
 		p_tmevtb->arg = (void *) p_runtsk;
-		tmevtb_enqueue(p_tmevtb, (RELTIM) tmout);
+		tmevtb_enqueue_reltim(p_tmevtb, (RELTIM) tmout);
 	}
 }
@@ -99,5 +100,5 @@
 	make_non_wait(p_tcb);
 	if (p_runtsk != p_schedtsk) {
-		request_dispatch();
+		request_dispatch_retint();
 	}
 
@@ -119,5 +120,5 @@
 	make_non_wait(p_tcb);
 	if (p_runtsk != p_schedtsk) {
-		request_dispatch();
+		request_dispatch_retint();
 	}
 
@@ -155,7 +156,7 @@
 
 void
-wobj_make_wait(WOBJCB *p_wobjcb, WINFO_WOBJ *p_winfo_wobj)
+wobj_make_wait(WOBJCB *p_wobjcb, uint_t tstat, WINFO_WOBJ *p_winfo_wobj)
 {
-	make_wait(&(p_winfo_wobj->winfo));
+	make_wait(tstat, &(p_winfo_wobj->winfo));
 	wobj_queue_insert(p_wobjcb);
 	p_winfo_wobj->p_wobjcb = p_wobjcb;
@@ -167,8 +168,8 @@
 
 void
-wobj_make_wait_tmout(WOBJCB *p_wobjcb, WINFO_WOBJ *p_winfo_wobj,
-								TMEVTB *p_tmevtb, TMO tmout)
+wobj_make_wait_tmout(WOBJCB *p_wobjcb, uint_t tstat,
+						WINFO_WOBJ *p_winfo_wobj, TMEVTB *p_tmevtb, TMO tmout)
 {
-	make_wait_tmout(&(p_winfo_wobj->winfo), p_tmevtb, tmout);
+	make_wait_tmout(tstat, &(p_winfo_wobj->winfo), p_tmevtb, tmout);
 	wobj_queue_insert(p_wobjcb);
 	p_winfo_wobj->p_wobjcb = p_wobjcb;
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/wait.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/wait.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/wait.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -77,11 +77,12 @@
  *  待ち状態への遷移
  *
- *  実行中のタスクを待ち状態に遷移させる．具体的には，実行中のタスクを
- *  レディキューから削除し，TCBのp_winfoフィールド，WINFOのp_tmevtbフィー
- *  ルドを設定する．
- */
-Inline void
-make_wait(WINFO *p_winfo)
-{
+ *  実行中のタスクを待ち状態に遷移させる．具体的には，実行中のタスクの
+ *  タスク状態をtstatにしてレディキューから削除し，TCBのp_winfoフィー
+ *  ルド，WINFOのp_tmevtbフィールドを設定する．
+ */
+Inline void
+make_wait(uint_t tstat, WINFO *p_winfo)
+{
+	p_runtsk->tstat = tstat;
 	make_non_runnable(p_runtsk);
 	p_runtsk->p_winfo = p_winfo;
@@ -93,9 +94,10 @@
  *
  *  実行中のタスクを，タイムアウト指定付きで待ち状態に遷移させる．具体
- *  的には，実行中のタスクをレディキューから削除し，TCBのp_winfoフィー
- *  ルド，WINFOのp_tmevtbフィールドを設定する．また，タイムイベントブ
- *  ロックを登録する．
- */
-extern void	make_wait_tmout(WINFO *p_winfo, TMEVTB *p_tmevtb, TMO tmout);
+ *  的には，実行中のタスクのタスク状態をtstatにしてレディキューから削
+ *  除し，TCBのp_winfoフィールド，WINFOのp_tmevtbフィールドを設定する．
+ *  また，タイムイベントブロックを登録する．
+ */
+extern void	make_wait_tmout(uint_t tstat, WINFO *p_winfo,
+									TMEVTB *p_tmevtb, TMO tmout);
 
 /*
@@ -246,7 +248,8 @@
  *  wobj_make_wait_tmoutは，タイムイベントブロックの登録も行う．
  */
-extern void	wobj_make_wait(WOBJCB *p_wobjcb, WINFO_WOBJ *p_winfo);
-extern void	wobj_make_wait_tmout(WOBJCB *p_wobjcb, WINFO_WOBJ *p_winfo,
-											TMEVTB *p_tmevtb, TMO tmout);
+extern void	wobj_make_wait(WOBJCB *p_wobjcb, uint_t tstat,
+				 							WINFO_WOBJ *p_winfo_wobj);
+extern void	wobj_make_wait_tmout(WOBJCB *p_wobjcb, uint_t tstat,
+						WINFO_WOBJ *p_winfo_wobj, TMEVTB *p_tmevtb, TMO tmout);
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/library/log_output.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/library/log_output.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/library/log_output.c	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -174,8 +174,10 @@
 		syslog_printf((const char *)(p_syslog->logpar[0]),
 								&(p_syslog->logpar[1]), putc);
+		(*putc)('\n');
 		break;
 	case LOG_TYPE_ASSERT:
 		syslog_printf("%s:%u: Assertion `%s' failed.",
 								&(p_syslog->logpar[0]), putc);
+		(*putc)('\n');
 		break;
 	default:
Index: EcnlProtoTool/trunk/asp3_dcre/library/t_perror.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/library/t_perror.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/library/t_perror.c	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -48,9 +48,20 @@
 #include <t_stdlib.h>
 
+#ifndef TOPPERS_OMIT_SYSLOG
+
+static const char	message[] = "%s (%d) reported by `%s' in line %d of `%s'.";
+
 void
-t_perror(uint_t prio, const char *file, int_t line, const char *expr, ER ercd)
+tt_perror(SYSLOG *p_logbuf, const char *file, int_t line,
+		 									const char *expr, ER ercd)
 {
-	syslog_5(prio, "%s (%d) reported by `%s' in line %d of `%s'.",
-						itron_strerror(ercd), SERCD(ercd), expr, line, file);
+	p_logbuf->logtype = LOG_TYPE_COMMENT;
+	p_logbuf->logpar[0] = (LOGPAR) message;
+	p_logbuf->logpar[1] = (LOGPAR) itron_strerror(ercd);
+	p_logbuf->logpar[2] = (LOGPAR) SERCD(ercd);
+	p_logbuf->logpar[3] = (LOGPAR) expr;
+	p_logbuf->logpar[4] = (LOGPAR) line;
+	p_logbuf->logpar[5] = (LOGPAR) file;
+}
 
-}
+#endif /* TOPPERS_OMIT_SYSLOG */
Index: EcnlProtoTool/trunk/asp3_dcre/library/vasyslog.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/library/vasyslog.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/library/vasyslog.c	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -51,13 +51,12 @@
 
 void
-vsyslog(uint_t prio, const char *format, va_list ap)
+tt_syslog(SYSLOG *p_logbuf, const char *format, va_list ap)
 {
-	SYSLOG	logbuf;
 	uint_t	i;
 	char	sz;
 	char	c;
 
-	logbuf.logtype = LOG_TYPE_COMMENT;
-	logbuf.logpar[0] = (LOGPAR) format;
+	p_logbuf->logtype = LOG_TYPE_COMMENT;
+	p_logbuf->logpar[0] = (LOGPAR) format;
 	i = 1U;
 
@@ -78,25 +77,25 @@
 		switch (c) {
 		case 'd':
-			logbuf.logpar[i++] = (sz == 'l') ? (LOGPAR) va_arg(ap, long_t)
-							   : (sz == 't') ? (LOGPAR) va_arg(ap, int32_t)
-							   : (sz == 'T') ? (LOGPAR) va_arg(ap, SYSTIM)
-							   : (LOGPAR) va_arg(ap, int_t);
+			p_logbuf->logpar[i++] = (sz == 'l') ? (LOGPAR) va_arg(ap, long_t)
+								  : (sz == 't') ? (LOGPAR) va_arg(ap, int32_t)
+								  : (sz == 'T') ? (LOGPAR) va_arg(ap, SYSTIM)
+								  : (LOGPAR) va_arg(ap, int_t);
 			break;
 		case 'u':
 		case 'x':
 		case 'X':
-			logbuf.logpar[i++] = (sz == 'l') ? (LOGPAR) va_arg(ap, ulong_t)
-							   : (sz == 't') ? (LOGPAR) va_arg(ap, uint32_t)
-							   : (sz == 'T') ? (LOGPAR) va_arg(ap, SYSTIM)
-							   : (LOGPAR) va_arg(ap, uint_t);
+			p_logbuf->logpar[i++] = (sz == 'l') ? (LOGPAR) va_arg(ap, ulong_t)
+								  : (sz == 't') ? (LOGPAR) va_arg(ap, uint32_t)
+								  : (sz == 'T') ? (LOGPAR) va_arg(ap, SYSTIM)
+								  : (LOGPAR) va_arg(ap, uint_t);
 			break;
 		case 'p':
-			logbuf.logpar[i++] = (LOGPAR) va_arg(ap, void *);
+			p_logbuf->logpar[i++] = (LOGPAR) va_arg(ap, void *);
 			break;
 		case 'c':
-			logbuf.logpar[i++] = (LOGPAR) va_arg(ap, int);
+			p_logbuf->logpar[i++] = (LOGPAR) va_arg(ap, int);
 			break;
 		case 's':
-			logbuf.logpar[i++] = (LOGPAR) va_arg(ap, const char *);
+			p_logbuf->logpar[i++] = (LOGPAR) va_arg(ap, const char *);
 			break;
 		case '\0':
@@ -107,24 +106,4 @@
 		}
 	}
-	(void) tSysLog_eSysLog_write(prio, &logbuf);
-}
-
-void
-syslog(uint_t prio, const char *format, ...)
-{
-	va_list	ap;
-	va_start(ap, format);
-	vsyslog(prio, format, ap);
-	va_end(ap);
-}
-
-/* mbed weak error function */
-void
-error(const char* format, ...) {
-	va_list arg;
-	va_start(arg, format);
-	vsyslog(LOG_ERROR, format, arg);
-	va_end(arg);
-	ext_ker();
 }
 
Index: EcnlProtoTool/trunk/asp3_dcre/mbed/Makefile.mbed
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/mbed/Makefile.mbed	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/mbed/Makefile.mbed	(revision 429)
@@ -14,12 +14,19 @@
 #
 INCLUDES := $(INCLUDES)\
-	-I$(MBEDDIR)/api\
+	-I$(MBEDDIR)\
+	-I$(MBEDDIR)/cmsis\
+	-I$(MBEDDIR)/cmsis/TARGET_CORTEX_A\
 	-I$(MBEDDIR)/hal\
-	-I$(MBEDDIR)/targets/cmsis\
-	-I$(MBEDDIR)/targets/cmsis/TARGET_RENESAS/TARGET_RZ_A1H\
-	-I$(MBEDDIR)/targets/cmsis/TARGET_RENESAS/TARGET_RZ_A1H/inc\
-	-I$(MBEDDIR)/targets/cmsis/TARGET_RENESAS/TARGET_RZ_A1H/inc/iodefines\
-	-I$(MBEDDIR)/targets/hal/TARGET_RENESAS/TARGET_RZ_A1H\
-	-I$(MBEDDIR)/targets/hal/TARGET_RENESAS/TARGET_RZ_A1H/TARGET_MBED_MBRZA1H
+	-I$(MBEDDIR)/platform\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/TARGET_MBED_MBRZA1H\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/device\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/device/inc\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/device/inc/iobitmasks\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/device/inc/iodefines\
+	-I$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/common\
+	-I$(MBEDDIR)/rtos/TARGET_CORTEX
 COPTS := $(COPTS)\
   -mthumb\
@@ -39,12 +46,55 @@
   -mno-unaligned-access
 CDEFS := $(CDEFS)\
-	-DTARGET_RZ_A1H\
-	-DTARGET_MBRZA1H\
-	-DTOOLCHAIN_GCC_ARM\
-	-DTOOLCHAIN_GCC\
-	-DTARGET_CORTEX_A\
-	-DMBED_BUILD_TIMESTAMP=1460441486.52\
-	-DTARGET_RENESAS\
-	-D__FPU_PRESENT
+	-DARM_MATH_CA9 \
+	-DDEVICE_ANALOGIN=1 \
+	-DDEVICE_CAN=1 \
+	-DDEVICE_EMAC=1 \
+	-DDEVICE_ETHERNET=1 \
+	-DDEVICE_FLASH=1 \
+	-DDEVICE_I2C=1 \
+	-DDEVICE_I2CSLAVE=1 \
+	-DDEVICE_I2C_ASYNCH=1 \
+	-DDEVICE_INTERRUPTIN=1 \
+	-DDEVICE_LPTICKER=1 \
+	-DDEVICE_PORTIN=1 \
+	-DDEVICE_PORTINOUT=1 \
+	-DDEVICE_PORTOUT=1 \
+	-DDEVICE_PWMOUT=1 \
+	-DDEVICE_RTC=1 \
+	-DDEVICE_SEMIHOST=1 \
+	-DDEVICE_SERIAL=1 \
+	-DDEVICE_SERIAL_ASYNCH=1 \
+	-DDEVICE_SERIAL_FC=1 \
+	-DDEVICE_SLEEP=1 \
+	-DDEVICE_SPI=1 \
+	-DDEVICE_SPISLAVE=1 \
+	-DDEVICE_SPI_ASYNCH=1 \
+	-DDEVICE_STDIO_MESSAGES=1 \
+	-DDEVICE_USTICKER=1 \
+	-DMBED_BUILD_TIMESTAMP=1550103323.92 \
+	-DTARGET_A9 \
+	-DTARGET_CORTEX \
+	-DTARGET_CORTEX_A \
+	-DTARGET_FF_ARDUINO \
+	-DTARGET_LIKE_CORTEX_A9 \
+	-DTARGET_LIKE_MBED \
+	-DTARGET_MBRZA1H \
+	-DTARGET_RELEASE \
+	-DTARGET_RENESAS \
+	-DTARGET_RZA1H \
+	-DTARGET_RZ_A1H \
+	-DTARGET_RZ_A1XX \
+	-DTARGET_RZ_A1_EMAC \
+	-DTOOLCHAIN_GCC \
+	-DTOOLCHAIN_GCC_ARM \
+	-DTOOLCHAIN_object \
+	-D__CMSIS_RTOS \
+	-D__CORTEX_A9 \
+	-D__EVAL \
+	-D__FPU_PRESENT=1 \
+	-D__MBED_CMSIS_RTOS_CA9 \
+	-D__MBED__=1 \
+	-DIRQ_GIC_LINE_COUNT=587 \
+	#-DDEVICE_STDIO_MESSAGES=1
 
 #
@@ -52,20 +102,30 @@
 #
 SYSSVC_DIRS := $(SYSSVC_DIRS)\
-	$(MBEDDIR)/common\
-	$(MBEDDIR)/targets/cmsis/TARGET_RENESAS/TARGET_RZ_A1H\
-	$(MBEDDIR)/targets/cmsis/TARGET_RENESAS/TARGET_RZ_A1H/TOOLCHAIN_GCC_ARM\
-	$(MBEDDIR)/targets/cmsis/TOOLCHAIN_GCC/TARGET_CORTEX_A\
-	$(MBEDDIR)/targets/hal/TARGET_RENESAS/TARGET_RZ_A1H
-SYSSVC_ASMOBJS := $(SYSSVC_ASMOBJS)\
-	cache.o
-START_OBJS = startup_RZ1AH.o
+	$(MBEDDIR)\
+	$(MBEDDIR)/hal\
+	$(MBEDDIR)/platform\
+	$(MBEDDIR)/cmsis/TARGET_CORTEX_A\
+	$(MBEDDIR)/targets/TARGET_RENESAS\
+	$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX\
+	$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H\
+	$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/TARGET_MBED_MBRZA1H\
+	$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/device\
+	$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/TARGET_RZ_A1H/device/TOOLCHAIN_GCC_ARM\
+	$(MBEDDIR)/targets/TARGET_RENESAS/TARGET_RZA1XX/common
+SYSSVC_ASMOBJS := $(SYSSVC_ASMOBJS)
+START_OBJS := startup_RZ1AH.o
+START_OBJS := $(addprefix $(OBJDIR)/, $(START_OBJS))
 SYSSVC_COBJS := $(SYSSVC_COBJS)\
-	assert.o board.o gpio.o lp_ticker_api.o mbed_interface.o\
-	pinmap_common.o rtc_time.o semihost_api.o ticker_api.o us_ticker_api.o\
-	RZ_A1_Init.o cmsis_nvic.o gic.o mbed_sf_boot.o mmu_Renesas_RZ_A1.o\
-	nvic_wrapper.o pl310.o rza_io_regrw.o system_MBRZA1H.o\
-	analogin_api.o can_api.o ethernet_api.o gpio_api.o gpio_irq_api.o i2c_api.o\
-	pinmap.o port_api.o pwmout_api.o rtc_api.o serial_api.o spi_api.o
-	#wait_api.o us_ticker.o
-CFG_DMY := cfg_dmy.o mmu_Renesas_RZ_A1.o mbed_sf_boot.o RZ_A1_Init.o system_MBRZA1H.o cache.o pl310.o gic.o
+	mbed_critical_section_api.o mbed_flash_api.o mbed_gpio.o mbed_lp_ticker_api.o\
+	mbed_lp_ticker_wrapper.o mbed_pinmap_common.o mbed_sleep_manager.o mbed_mktime.o\
+	mbed_ticker_api.o mbed_us_ticker_api.o mbed_assert.o mbed_board.o\
+	mbed_critical.o mbed_error.o mbed_error_hist.o mbed_interface.o\
+	mbed_rtc_time.o mbed_semihost_api.o mbed_stats.o\
+	PeripheralPins.o RZ_A1_Init.o mbed_sf_boot.o mmu_RZ_A1H.o\
+	system_RZ_A1H.o trng_api_esp32.o analogin_api.o can_api.o cmsis_nvic.o\
+	irq_ctrl_gic.o nvic_wrapper.o rza_io_regrw.o ethernet_api.o flash_api.o\
+	gpio_api.o gpio_irq_api.o i2c_api.o lp_ticker.o mtu2.o pinmap.o port_api.o\
+	pwmout_api.o rtc_api.o serial_api.o sleep.o spi_api.o trng_api.o us_ticker.o
+	#mbed_wait_api_no_rtos.o
+CFG_DMY := cfg_dmy.o mmu_RZ_A1H.o mbed_sf_boot.o RZ_A1_Init.o system_RZ_A1H.o irq_ctrl_gic.o
 
Index: EcnlProtoTool/trunk/asp3_dcre/mbed/cmsis/RTE_Components.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/mbed/cmsis/RTE_Components.h	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/mbed/cmsis/RTE_Components.h	(revision 429)
@@ -0,0 +1,26 @@
+/* mbed Microcontroller Library
+ * Copyright (c) 2018 ARM Limited
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+#ifndef RTE_COMPONENTS_H
+#define RTE_COMPONENTS_H
+
+#define CMSIS_device_header <cmsis.h>
+
+#if defined(MBED_CONF_RTOS_PRESENT)
+#include "mbed_rtx_conf.h"
+#endif
+#include "mbed_cmsis_conf.h"
+
+#endif
